$IF DEFINED (WNT)
      include 'opn3.fi'
$ELSE
      include 'opn.fi'
$ENDIF
      SUBROUTINE GETINPFILENAME(MSG, DIR, NFILT, FILT,
     &  PATHFILE, READONLY)
      character*(*) msg, dir, pathfile  ! Formal params
      structure /s_filt/                ! Formal param
        character*20 desc, mask
      endstructure
      record /s_filt/ filt(nfilt)       ! Filter list
      logical readonly                  ! Checkbox stat
      include 'opn.fd'                  ! Defines s_ofn
      record /s_ofn/ ofn                ! Arg for Dlgs
      character*256 szDirName, szFile, szFileTitle
      character*256 szTitle,   szFilter*512
      automatic
$IF DEFINED (WNT)
      integer*4 GetFocus
$ELSE
      integer*2 GetFocus
$ENDIF
      integer*4 CommDlgExtendedError, lstatus
      logical*2 GetOpenFileName, GetSaveFileName, ok
      logical*2 input
      input = .TRUE.                    ! Input file
      go to 10
c
      ENTRY GETOUTFILENAME(MSG, DIR, NFILT, FILT,
     &  PATHFILE, READONLY)
      input = .FALSE.                   ! Output file
c
c     File-Opening Common Dialog Example Subroutine
c     Kenneth G. Hamilton - Windows/DOS Dev Journal
c     Compose the filter string:
c
   10 szFilter = ' '                    ! Init to blank
      ip = 1                            ! Char position
      do i = 1, nfilt                   ! Loop over all
        nc = len_trim(filt(i).desc)     ! Description
        szFilter(ip:ip+nc) = filt(i).desc(:nc)//char(0)
        ip = ip + nc + 1                ! Inc position
        nc = len_trim(filt(i).mask)     ! Filter proper
        szFilter(ip:ip+nc) = filt(i).mask(:nc)//char(0)
        ip = ip + nc + 1                ! Inc position
      enddo
      szFilter(ip:ip) = char(0)         ! Second NULL
c
      szFile(1:1) = char(0)             ! d:\path\file
      szFileTitle(1:1) = char(0)        ! file name
      nch = len_trim(dir)               ! Count chrs
      szDirName = dir                   ! Copy init dir
      szDirName(nch+1:nch+1) = char(0)  !   plus a NULL
      nch = len_trim(msg)               ! Count chrs
      szTitle = msg                     ! Boxtop title
      szTitle(nch+1:nch+1) = char(0)    !   plus a NULL
c
c     Fill the OPENFILENAME structure for input
c
      ofn.lStructSize = loc(ofn.lpTemplateName) - 
     &  loc(ofn.lStructSize) + 4        ! Struct Size
      ofn.hwndOwner   = GetFocus()      ! Popup over
      ofn.hInstance   = 0               ! Don't need
      ofn.lpstrFilter = loc(szFilter)   ! Addr(filter)
      ofn.lpstrCustomFilter = 0         ! Don't need
      ofn.nMaxCustFilter  = 0           ! Don't need
      ofn.nFilterIndex    = 1           ! 1st filter
      ofn.lpstrFile       = loc(szFile) ! Addr(pth\fil)
      ofn.nMaxFile        = len(szFile) ! Size(buffer)
      ofn.lpstrFileTitle  = loc(szFileTitle) ! Adr(fil)
      ofn.nMaxFileTitle   = len(szFileTitle) ! Siz(buf)
      ofn.lpstrInitialDir = loc(szDirName)   ! Adr(dir)
      ofn.lpstrTitle      = loc(szTitle)     ! Adr(top)
      ofn.lpstrDefExt       = 0         ! Not using
      ofn.lCustDate         = 0         ! Zero out
      ofn.lpfnHook          = 0         ! to prevent
      ofn.lpTemplateName    = 0         ! activating
c
      if (input) then
        ofn.Flags = OFN_PATHMUSTEXIST + OFN_FILEMUSTEXIST
        ok = GetOpenFileName(ofn)       ! Call dialog
      else
        ofn.Flags = OFN_PATHMUSTEXIST
     &            + OFN_OVERWRITEPROMPT + OFN_HIDEREADONLY
        ok = GetSaveFileName(ofn)       ! Call dialog
      endif
c
      if (ok) then                      ! It worked
        nch = index(szFile,char(0)) - 1 ! Length
        pathfile = szFile(:nch)         ! Get qualname
        readonly = iand(ofn.Flags,OFN_READONLY).ne.0
      else                              ! No good
        lstatus = CommDlgExtendedError()
        print 90, lstatus               ! Show error
   90   format (' Error status ',Z8,'(hex) occurred')
        pathfile = ' '
        readonly = .FALSE.
      endif
c
      return
      end
